"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = singletonAsync;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var last = function last(arr) {
  return arr[arr.length - 1];
};

function singletonAsync(func) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      trailing = _ref.trailing;

  if (typeof func !== 'function') throw new Error('argument is not function.');
  var running = false;
  var queue = [];
  return function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return new Promise(
    /*#__PURE__*/
    function () {
      var _ref2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(resolve) {
        var result, _last, _args;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!running) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return", queue.push({
                  resolve: resolve,
                  args: args
                }));

              case 2:
                running = true;
                _context.next = 5;
                return func.apply(void 0, args);

              case 5:
                result = _context.sent;
                resolve(result);

                if (!(queue.length > 0)) {
                  _context.next = 15;
                  break;
                }

                if (!trailing) {
                  _context.next = 13;
                  break;
                }

                _last = last(queue), _args = _last.args;
                _context.next = 12;
                return func.apply(void 0, _toConsumableArray(_args));

              case 12:
                result = _context.sent;

              case 13:
                queue.forEach(function (_ref3) {
                  var resolve = _ref3.resolve;
                  return resolve(result);
                });
                queue = [];

              case 15:
                running = false;

              case 16:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }());
  };
}